#include <Wire.h>
#include <SoftwareSerial.h>
#include "MAX30100_PulseOximeter.h"


SoftwareSerial screenserial(10, 11); // RX, TX
PulseOximeter pox;


#define Heart_dis_addr 0x01
#define Sop2_dis_addr 0x05
#define connect_sta_addr 0x08
unsigned char heart_rate_send[8]= {0xA5, 0x5A, 0x05, 0x82,\
0x00, Heart_dis_addr, 0x00, 0x00};
unsigned char Sop2_send[8]= {0xA5, 0x5A, 0x05, 0x82, 0x00, \
Sop2_dis_addr, 0x00, 0x00};
unsigned char connect_sta_send[8]={0xA5, 0x5A, 0x05, 0x82, 0x00, \
connect_sta_addr,0x00, 0x00};

#define REPORTING_PERIOD_MS 1000

uint32_t tsLastReport = 0;

void setup()

{
  screenserial.begin(115200);
  Serial.begin(9600);
  Serial.print("Initializing pulse oximeter..");
  Initialize the PulseOximeter instance
  if (!pox.begin()) 
  {
    Serial.println("FAILED");
    connect_sta_send[7]=0x00;
    screenserial.write(connect_sta_send,8);

    for(;;);

  } 
  else 
  {
    connect_sta_send[7]=0x01;
    screenserial.write(connect_sta_send,8);
    Serial.println("SUCCESS");

  }
  // The default current for the IR LED is 50mA and it could be changedby uncommenting the following line. Check MAX30100_Registers.h for all theavailable options.
  pox.setIRLedCurrent(MAX30100_LED_CURR_7_6MA);
}

void loop()
{ 
  // Make sure to call update as fast as possible
  pox.update();
  // Asynchronously dump heart rate and oxidation levels to the serial
  // For both, a value of 0 means "invalid"
  if (millis() - tsLastReport > REPORTING_PERIOD_MS)
  {
    Serial.print("Heart rate:");
    Serial.print(pox.getHeartRate());
    Serial.print("bpm / SpO2:");
    Serial.print(pox.getSpO2());
    Serial.println("%");
    heart_rate_send[7]=(uint32_t)pox.getHeartRate();
    screenserial.write(heart_rate_send,8);// send heart rate to display
    Sop2_send[7]=pox.getSpO2();
    screenserial.write(Sop2_send,8);// send oxygen level to display. 
    tsLastReport = millis();

  }

}
